
/**
 * @internal Defines the types of Autodiscover endpoints that are available.
 * 
 * [Flags]
 */
export enum AutodiscoverEndpoints {

    /**
     * No endpoints available.
     */
    None = 0,
    
    /**
     * The "legacy" Autodiscover endpoint.
     */
    Legacy = 1,
    
    /**
     * The SOAP endpoint.
     */
    Soap = 2,
    
    /**
     * The WS-Security endpoint.
     */
    WsSecurity = 4,
    
    /**
     * The WS-Security/SymmetricKey endpoint.
     */
    WSSecuritySymmetricKey = 8,
    
    /**
     * The WS-Security/X509Cert endpoint.
     */
    WSSecurityX509Cert = 16,
    
    /**
     * The OAuth endpoint
     */
    OAuth = 32
}