
/**
 * The values indicate the types of item icons to display.
 */
export enum IconIndex {

    /**
     * A default icon.
     */
    Default = 0,

    /**
     * Post Item
     */
    PostItem = 1,

    /**
     * Icon read
     */
    MailRead = 2,

    /**
     * Icon unread
     */
    MailUnread = 3,

    /**
     * Icon replied
     */
    MailReplied = 4,

    /**
     * Icon forwarded
     */
    MailForwarded = 5,

    /**
     * Icon encrypted
     */
    MailEncrypted = 6,

    /**
     * Icon S/MIME signed
     */
    MailSmimeSigned = 7,

    /**
     * Icon encrypted replied
     */
    MailEncryptedReplied = 8,

    /**
     * Icon S/MIME signed replied
     */
    MailSmimeSignedReplied = 9,

    /**
     * Icon encrypted forwarded
     */
    MailEncryptedForwarded = 10,

    /**
     * Icon S/MIME signed forwarded
     */
    MailSmimeSignedForwarded = 11,

    /**
     * Icon encrypted read
     */
    MailEncryptedRead = 12,

    /**
     * Icon S/MIME signed read
     */
    MailSmimeSignedRead = 13,

    /**
     * IRM-protected mail
     */
    MailIrm = 14,

    /**
     * IRM-protected mail forwarded
     */
    MailIrmForwarded = 15,

    /**
     * IRM-protected mail replied
     */
    MailIrmReplied = 16,

    /**
     * Icon sms routed to external messaging system
     */
    SmsSubmitted = 17,

    /**
     * Icon sms routed to external messaging system
     */
    SmsRoutedToDeliveryPoint = 18,

    /**
     * Icon sms routed to external messaging system
     */
    SmsRoutedToExternalMessagingSystem = 19,

    /**
     * Icon sms routed to external messaging system
     */
    SmsDelivered = 20,

    /**
     * Outlook Default for Contacts
     */
    OutlookDefaultForContacts = 21,

    /**
     * Icon appointment item
     */
    AppointmentItem = 22,

    /**
     * Icon appointment recur
     */
    AppointmentRecur = 23,

    /**
     * Icon appointment meet
     */
    AppointmentMeet = 24,

    /**
     * Icon appointment meet recur
     */
    AppointmentMeetRecur = 25,

    /**
     * Icon appointment meet NY
     */
    AppointmentMeetNY = 26,

    /**
     * Icon appointment meet yes
     */
    AppointmentMeetYes = 27,

    /**
     * Icon appointment meet no
     */
    AppointmentMeetNo = 28,

    /**
     * Icon appointment meet maybe
     */
    AppointmentMeetMaybe = 29,

    /**
     * Icon appointment meet cancel
     */
    AppointmentMeetCancel = 30,

    /**
     * Icon appointment meet info
     */
    AppointmentMeetInfo = 31,

    /**
     * Icon task item
     */
    TaskItem = 32,

    /**
     * Icon task recur
     */
    TaskRecur = 33,

    /**
     * Icon task owned
     */
    TaskOwned = 34,

    /**
     * Icon task delegated
     */
    TaskDelegated = 35
}