
/**
 * Defines phone number entries for a contact.
 */
export enum PhoneNumberKey {
    
    /**
     * The assistant's phone number.
     */
    AssistantPhone = 0,
    
    /**
     * The business fax number.
     */
    BusinessFax = 1,
    
    /**
     * The business phone number.
     */
    BusinessPhone = 2,
    
    /**
     * The second business phone number.
     */
    BusinessPhone2 = 3,
    
    /**
     * The callback number.
     */
    Callback = 4,
    
    /**
     * The car phone number.
     */
    CarPhone = 5,
    
    /**
     * The company's main phone number.
     */
    CompanyMainPhone = 6,
    
    /**
     * The home fax number.
     */
    HomeFax = 7,
    
    /**
     * The home phone number.
     */
    HomePhone = 8,
    
    /**
     * The second home phone number.
     */
    HomePhone2 = 9,
    
    /**
     * The ISDN number.
     */
    Isdn = 10,
    
    /**
     * The mobile phone number.
     */
    MobilePhone = 11,
    
    /**
     * An alternate fax number.
     */
    OtherFax = 12,
    
    /**
     * An alternate phone number.
     */
    OtherTelephone = 13,
    
    /**
     * The pager number.
     */
    Pager = 14,
    
    /**
     * The primary phone number.
     */
    PrimaryPhone = 15,
    
    /**
     * The radio phone number.
     */
    RadioPhone = 16,
    
    /**
     * The Telex number
     */
    Telex = 17,
    
    /**
     * The TTY/TTD phone number.
     */
    TtyTddPhone = 18
}