
/**
 * Identifies the user configuration dictionary key and value types.
 */
export enum UserConfigurationDictionaryObjectType {

    /**
     * DateTime type.
     */
    DateTime = 0,

    /**
     * Boolean type.
     */
    Boolean = 1,

    /**
     * Byte type.
     */
    Byte = 2,

    /**
     * String type.
     */
    String = 3,

    /**
     * 32-bit integer type.
     */
    Integer32 = 4,

    /**
     * 32-bit unsigned integer type.
     */
    UnsignedInteger32 = 5,

    /**
     * 64-bit integer type.
     */
    Integer64 = 6,

    /**
     * 64-bit unsigned integer type.
     */
    UnsignedInteger64 = 7,

    /**
     * String array type.
     */
    StringArray = 8,

    /**
     * Byte array type
     */
    ByteArray = 9
}